<?php
	/**
	 * Module for payment provide by ELP
	 * Copyright (C) 2017
	 *
	 * This file is part of ELP/EnLineaPagos.
	 *
	 * ELP/EnLineaPagos is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU General Public License as published by
	 * the Free Software Foundation, either version 3 of the License, or
	 * (at your option) any later version.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	 * GNU General Public License for more details.
	 *
	 * You should have received a copy of the GNU General Public License
	 * along with this program. If not, see <http://www.gnu.org/licenses/>.
	 */
	
	namespace Medianet\Pay\Controller\Medianet;
	
	
	class Index extends \Magento\Framework\App\Action\Action
	{
		
		protected $resultPageFactory;
		protected $resultJsonFactory;
		protected $checkoutSession;
		protected $orderFactory;
		protected $cartManagement;
		protected $quote;
		protected $resultRedirect;
		protected $_curl;
		protected $request;
		
		/**
		 * Constructor
		 *
		 * @param \Magento\Framework\App\Action\Context  $context
		 * @param \Magento\Framework\Json\Helper\Data $jsonHelper
		 */
		public function __construct(
			\Magento\Framework\App\Action\Context $context,
			\Magento\Framework\View\Result\PageFactory $resultPageFactory,
			\Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
			\Magento\Checkout\Model\Session $checkoutSession,
			\Magento\Sales\Model\OrderFactory $orderFactory,
			\Magento\Quote\Api\CartManagementInterface $cartManagement,
			\Magento\Quote\Model\Quote $quote,
			\Magento\Framework\HTTP\Client\Curl $curl,
			\Magento\Framework\App\Helper\Context $contextApp,
			\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
			\Medianet\Pay\Controller\PaymentController $payment_controller,
			\Magento\Sales\Api\OrderRepositoryInterface $orderRepository
		
			
			
		) {
			$this->resultPageFactory = $resultPageFactory;
			$this->resultJsonFactory = $resultJsonFactory;
			$this->checkoutSession = $checkoutSession;
			$this->orderFactory = $orderFactory;
			$this->cartManagement = $cartManagement;
			$this->quote = $quote;
			$this->_curl = $curl;
			$this->contextApp = $contextApp;
			$this->scopeConfig = $scopeConfig;
			$this->paymentController = $payment_controller;
			$this->orderRepository = $orderRepository;
			parent::__construct($context);
		}
		
		/**
		 * Execute view action
		 *
		 * @return \Magento\Framework\Controller\ResultInterface
		 */
		public function execute()
		{
//			return $this->resultPageFactory->create();
			//$resultPage = $this->resultPageFactory->create();
			//$resultPage->getConfig()->getTitle()->prepend(__('Custom Front View'));
			//return $resultPage;
			
			$result = $this->resultJsonFactory->create();
			$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
			$urlRedirect = $this->scopeConfig->getValue('payment/medianet/medianet_callback',$storeScope);
		

			$fecha=date('l jS \of F Y h:i:s A');	
			$referencia = $_GET['referencia'];	
			$moneda = $_GET['moneda'];	
			$valor= $_GET['valor'];	
			$respuesta= $_GET['respuesta'];	
			/*$cuentanro= $_REQUEST['cuentanro'];	
			$metodousado= $_REQUEST['metodousado'];	
			$autorizacion= $_REQUEST ['autorizacion'];	
			$nrotransaccion= $_REQUEST['nrotransaccion'];	*/
			

			if(isset($respuesta)){
					
				$objectManager = \Magento\Framework\App\ObjectManager::getInstance();

				$orderId = (Integer)$referencia;
				$order = $objectManager->create('\Magento\Sales\Model\Order')->loadByAttribute('quote_id',$orderId);

				if($respuesta == "aprobada"){
					$order->setState("complete")->setStatus("complete");
				} else{
					$order->setState("canceled")->setStatus("canceled");
				}

				try{
					$order->save();
				} catch(\Exception $e){
					if($urlRedirect != ''){
						return $this->resultRedirectFactory->create()->setUrl($urlRedirect);
					} else {
						return $this->resultRedirectFactory->create()->setUrl('/');
					}
				}
				
				if($urlRedirect != ''){
					return $this->resultRedirectFactory->create()->setUrl($urlRedirect);
				} else {
					return $this->resultRedirectFactory->create()->setUrl('/');
				}

				
			}else{
				die ("Error actualizando orden");
			}
				
		}

		public function getPost()
		{
			return $this->request->getPostValue();//in Magento 2.*
		}
		
		
		
		public function getRealOrderId()
		{
			$lastorderId = $this->checkoutSession->getLastOrderId();
			return $lastorderId;
		}
		
		public function getOrder()
		{
			if ($this->checkoutSession->getLastRealOrderId()) {
				$order = $this->orderFactory->create()->loadByIncrementId($this->checkoutSession->getLastRealOrderId());
				return $order;
			}
			return false;
		}
		
		public function getShippingInfo()
		{
			$order = $this->getOrder();
			if($order) {
				$address = $order->getShippingAddress();
				
				return $address;
			}
			return false;
			
		}
		
		
	}